function FuelMeter(){}

var LastmsCount;
var speedMs;
var TravelledDistanceTemp = 0;
var TravelledDistance = 0;
var FuelOld;
var iHilf;

	FuelMeter.prototype.initialize = function()
{
    this.fuelDiv = $('<div></div>').appendTo(this.rootElement).addClass('fuelDiv');
	this.Avg = $('<div></div>').appendTo(this.rootElement).addClass('Avg');
	this.Dist = $('<div></div>').appendTo(this.rootElement).addClass('Dist');
	this.labelDiv = $('<div></div>').appendTo(this.rootElement).addClass('labelDiv');

    this.labelDiv.click(function(){self.toggleUnits();});
	
	var self = this;

    if ((this.persistance.Unit != "L/100km") && (this.persistance.Unit != "MPG")) this.persistance.Unit = "L/100km";
};

FuelMeter.prototype.toggleUnits = function()
{
    //Toggle Between Miles / KM and L / Gallons
    this.persistance.Unit = this.persistance.Unit === 'L/100km' ? 'MPG' : 'L/100km';
    this.save();
};




FuelMeter.prototype.update = function (streams) {

if (isNaN(TravelledDistance))
	TravelledDistance = 0; //Init Var
	
if (isNaN(FuelOld))
	FuelOld = 0; //Init Var
	
if (isNaN(iHilf))
	iHilf = 0;
	
	iHilf++;
	
	var now = new Date;  //DateVar
	var ms = now.getTime(); //Reads ms since somewhen far back
    var FuelNew = streams.engineInfo[11]; //Read actual Fuel
	speedMs = streams.electrics.wheelspeed; //Get Wheelspeed
    var FuelConsumptionHelper;
	var FuelConsumptionMulti;
	var FuelConsumption;
	var TimeDiff;
	
	TimeDiff = ms - LastmsCount;
	
if ( iHilf == 100 ) //Avoid too many refreshes
{
	FuelConsumptionHelper = FuelOld - FuelNew;	//Getting to know how much fuel was burned since the Last Computation here
	FuelConsumptionMulti = 1 / TravelledDistanceTemp; // Multiplicator to get to know how much of 1 KM the TravelledDistance was
	var Multi = 0;									//Multiplicator
	for (i = 0; i < 100; i++) { 
	Multi = FuelConsumptionHelper.toFixed(7) * FuelConsumptionMulti.toFixed(7) * 100 + Multi; //Taking the Needed Amount of Fuel, Multiplicating it to get to know how much would be needed for 1KM und taking it times 100
	}
	FuelConsumption = Multi / 100;					//Building Average of 100
	iHilf = 0;

	if( streams.electrics.wheelspeed <= 1 )			//Switch to L/h when not driving
	{
		var timehelper;
		timehelper = ((1000*3600)/TimeDiff);
		var fuelperhour;
		fuelperhour = FuelConsumptionHelper * timehelper;
		if(this.persistance.Unit == "L/100km")		//Choose Output depending on Unit
		{
			this.fuelDiv.html("Cons.: " + String(fuelperhour).substr(0,4) + " " + "L/h");
		}
		else
		{
			this.fuelDiv.html("Cons.: " + String((fuelperhour*0.264172052)).substr(0,4) + " " + "GpH");
		}
	}
	else
	{
		if(this.persistance.Unit == "L/100km") //Choose Output depending on Unit
		{
			this.fuelDiv.html("Cons.: " + String(FuelConsumption).substr(0,4) + " " + this.persistance.Unit);
		}
		else
		{
			this.fuelDiv.html("Cons.: " + String((235.2146/FuelConsumption)).substr(0,4) + " " + this.persistance.Unit);
		}
}	}

	
	
	TravelledDistanceTemp = speedMs * (TimeDiff/1000000);
	TravelledDistance = TravelledDistanceTemp + TravelledDistance;
	FuelConsumptionAvg = (streams.engineInfo[12] - FuelNew) * (100 /TravelledDistance);
	
	if(this.persistance.Unit == "L/100km")
	{
		this.Dist.html("KM: " + String(TravelledDistance).substr(0,4));
	}
	else
	{
		this.Dist.html("Miles: " + String(TravelledDistance * 0.621371192).substr(0,4));
	}
	
	
	if ( TravelledDistance <= 0.1 )
	{
		this.Avg.html("Avg: " + "--.-" + " " + this.persistance.Unit);
	}
	else
	{
		if(this.persistance.Unit == "L/100km") //Choose Output depending on Unit
		{
			this.Avg.html("Avg: " + String(FuelConsumptionAvg).substr(0,4) + " " + this.persistance.Unit);
		}
		else
		{
			this.Avg.html("Avg: " + String((235.2146/FuelConsumptionAvg)).substr(0,4) + " " + this.persistance.Unit);
		}
	}
	LastmsCount = ms;
	FuelOld = FuelNew;
	this.labelDiv.html("Change Units");
};
